{--------------------------------------------------------}
{                                                        }
{    Programa acesso simplificado ao Google              }
{                                                        }
{    Mdulo de leitura interativa                        }
{                                                        }
{    Verso 1: Jos Antonio Borges e Fabiano Ferreira    }
{       Em maio/2013                                     }
{    Verso 2: Antonio Borges e Julio Tadeu Silveira     }
{       Em maio/2016                                     }
{    Verso 3: Antonio Borges e Julio Tadeu Silveira     }
{       Em maio/2019                                     }
{                                                        }
{--------------------------------------------------------}

program googlevox;
uses
  windows,
  shellapi,
  dvcrt,
  dvwin,
  dvinet,
  dvForm,
  dvssl,
  dvexec,
  SysUtils,
  classes,
  superobject,
  gvhttp,
  gvhtml,
  gvmsg,
  gvbusca,
  gvvars,
  gvfolheia;

{--------------------------------------------------------}
{        limpa debaixo de certa posio da tela          }
{--------------------------------------------------------}

procedure limpaBaixo (y: integer);
var i: integer;
begin
    for i := y to 25 do
        begin
            gotoxy (1, i);
            clreol;
        end;
    gotoxy (1, y);
end;

{--------------------------------------------------------}
{                       termina                          }
{--------------------------------------------------------}

procedure termina;
begin
    mensagem ('GVTCHAU', 1);  {'At a prxima, pessoal!'}
    sintFim;
    fechaWinsock;
    halt;
end;

{--------------------------------------------------------}
{                     inicializao                      }
{--------------------------------------------------------}

procedure inicializa;
var ambiente: string;
    i: integer;
begin
    setwindowtitle('GoogleVox');

    ambiente := sintAmbiente ('GOOGLEVOX', 'DIRGOOGLEVOX');
    if ambiente = '' then
       ambiente := 'C:\Winvox\Som\Googlevox';
    sintinic (0, ambiente);

    textBackground (BLUE);
    mensagem ('GVINIC', 0);  {'Acesso rpido ao Google - v.' + versao'}
    sintWriteln (versao);
    textBackground (BLACK);
    writeln;

    if not abreWinsock then
        begin
            mensagem ('GVNLIG', 1);  {'Seu computador no est ligado  Internet'}
            termina;
        end;

    siteGoogle := 'www.google.com';
    urlGoogle := '/';

    for i := 1 to 10 do
        ultimasBuscas[i] := sintAmbiente ('GOOGLEVOX', intToStr(i));

    cookies := TStringList.Create;
    debug := false;
end;

{--------------------------------------------------------}
{           escolhe uma entre as ltimas buscas          }
{--------------------------------------------------------}

function escolheBusca: string;
var i: integer;
begin
    garanteEspacoTela (10);
    popupMenuCria(wherex, wherey, 80, 10, MAGENTA);
    for i := 1 to 10 do
        if ultimasBuscas[i] <> '' then
            popupMenuAdiciona('', ultimasBuscas[i]);
    popupMenuSeleciona;
    result := opcoesItemSelecionado;
end;

{--------------------------------------------------------}
{                   processa um pedido                   }
{--------------------------------------------------------}

procedure processa;
var
    busca: string;
    nivelBusca: integer;
    c: char;
begin
    textBackground (BLUE);
    mensagem ('GVOQUE', 0);  {'Google - o que voc deseja buscar? '}
    textBackground (BLACK);
    writeln;

    busca := '';
    c := sintEdita (busca, wherex, wherey, 80, true);
    if c = BAIX then
        busca := escolheBusca;
    if (c = ESC) or (busca = '') then
        exit;

    sintWriteln (busca);

    if busca = 'malabinguaba' then
         debug := not debug;

nivelBusca := 1;
(*
    mensagem ('GVNIVEL', 0); {'Nvel da pesquisa, de 1 a 4? '}
    c := popupMenuPorLetra ('1234');
    if not (c in ['1'..'4']) then
        nivelBusca := 0
    else
        nivelBusca := strToInt(c);
*)
    if nivelBusca < 1 then
        begin
            mensagem ('GVDESIST', 1);  {'Desistiu'}
            exit;
        end;

    if nivelBusca > 4 then nivelBusca := 4;

    mensagem ('GVMOMENT', 1);   {'Um momento...'}

    resultado := TStringList.Create;
    buscaNoGoogle (busca, nivelBusca);

    if resultado.count <> 0 then
        selecionaDaBusca (busca)
    else
        mensagem ('GVNAOACH', 1);  {'No consegui achar o que voc procurava.'}
    resultado.free;
end;

{--------------------------------------------------------}
{                   programa principal                   }
{--------------------------------------------------------}

var c: char;
begin
    inicializa;
    if iniciaComunicGoogle then
      repeat
          processa;

          if not debug then
              limpabaixo (2);

          writeln;
          textBackground (RED);
          mensagem ('GVMAISB', 0); {'Mais buscas (s/n)? '}
          textBackground (BLACK);
          c := popupMenuPorLetra('SN');
          writeln;
      until upcase (c) <> 'S';

    termina;
end.

